/*************************************************************************************
 Data Visualization - 3d Assignment                
 Tested in Processing 3                                    
 
 Author: Hannah Wolfe                       
 Supervisor: George Legrady                           
 
 Purpose: Show how to present volume data in a basic 3D environment     

 To Do:
-add more to controlp5 interface
-Write a query that can actually collect all books, not just these books

Done:
-Fina a way to select all shapes which are connected to a word
-Make text look better
-Find a way to click on a point and list all points within a radius

 Usage: 
 1. A mouse left-drag will rotate the camera around the subject.
 2. A right drag will zoom in and out. 
 3. A middle-drag (command-left-drag on mac) will pan. 
 4. A double-cli
 +ck restores the camera to its original position. 
 5. The shift key constrains rotation and panning to one axis or the other.
 *************************************************************************************/
//cam.set_wheel_scale
import peasy.*;

import com.jogamp.opengl.GL;
import controlP5.*;

ControlP5 cp5;

PeasyCam cam;

PFont font;
PFont fontBold;
Table tableWords;
word [] wordRows;
int wordNumCols;
vec3f rangeWord = new vec3f(0,0,0);
vec3f rangeBook = new vec3f(0,0,0);
Table table;
int bookNumCols;
vec3f boxSize = new vec3f(300,300,300);
entry [] bookRows;
ArrayList<ArrayList<Integer>> titleLookup = new ArrayList<ArrayList<Integer>>();
ArrayList<String> authorList = new ArrayList<String>();
int maxCheckout;
String[] types = {"item", "medium", "genre", "cd/cas", "book", "sci", "mys", "wes", "fic", "ya"};
int typeP = 0;
String letter = " ";
boolean geometry = true;
boolean sentence = true;
int select = 0;
boolean near = false;
int nearIndex = 0;

RadioButton r;
RadioButton b;
Textlabel myTextlabelA;

void setup() {
  size(1920, 1080, P3D);
  cam = new PeasyCam(this, 250);
  fontBold = loadFont("Lato-Black-40.vlw");
  font = loadFont("Lato-Light-40.vlw");
  perspective(PI/3.0,(float)width/height,1,100000);
  
  tableWords = loadTable("tsne-justTitle-onlyOnePerBook.csv");
  wordNumCols = tableWords.getRowCount();
  wordRows = new word[wordNumCols];
  for (int i = 0; i < wordNumCols; i++) {
    vec3f t = new vec3f(tableWords.getFloat(i,0), tableWords.getFloat(i,1), tableWords.getFloat(i,2));
    wordRows[i] = new word(tableWords.getString(i,3),t);
    rangeWord = new vec3f(max(abs(t.x),rangeWord.x), max(abs(t.y),rangeWord.y), max(abs(t.z),rangeWord.z));
  }
  // order of rows and cols depends on orientation
  table = loadTable("output.csv", "header");
  bookNumCols = table.getRowCount();
  bookRows = new entry[bookNumCols];
  int a = 0;
  for (int i = 0; i < bookNumCols; i++) {
    String itemType = table.getString(i,8);
    String mediumType = table.getString(i,9);
    boolean returned = boolean(table.getInt(i,4));
    int checkoutDay = table.getInt(i,12);
    int checkinDay = table.getInt(i,13);
    String author = table.getString(i,10);
    String title = table.getString(i,6);
    String titled[] = split(title.toLowerCase(), ' ');
    ArrayList<Integer> titleArray = new ArrayList<Integer>();
    if (checkoutDay > maxCheckout) {
      maxCheckout = checkoutDay;
    }
    vec3f sum = new vec3f(0,0,0);
    for (int j = 0; j< titled.length; j++) {
      for (int k = 0; k < wordNumCols; k++) {
        if (trim(titled[j]).equals(trim(wordRows[k].word.toLowerCase())) == true) {
        //  println(titled[j] + " " + wordRows[k].word);
          titleArray.add(k);
          sum.add(wordRows[k].loc);
        }
      }
    }
    sum.div(titleArray.size());
    rangeBook = new vec3f(max(abs(sum.x),rangeBook.x), max(abs(sum.y),rangeBook.y), max(abs(sum.z),rangeBook.z));
    titleLookup.add(titleArray);
 //   println(b_returned[i]+ ":" + b_itemType[i]+ ":" +b_checkoutDay[i]+":" +b_checkinDay[i]);
    
    addAuthor(author, authorList, a);
    bookRows[i] = new entry(returned, a, checkoutDay, checkinDay, itemType, mediumType, author, title, sum);

  }
  
  guiSetup();
  
  println("the title never gets known");
  println(maxCheckout);
//  print(titleLookup);

}

void draw() {
  background(100);
  
  if (cp5.getWindow().isMouseOver()) {
    cam.setActive(false);
  } else {
    cam.setActive(true);
  }
  
  background(100);
  if (!sentence) {
    if (geometry) {
      if (near) {
        drawLines(true);
      } else {
        drawGeometry();
      }
    } else if (near) {
      drawLines(false);
    }
    drawWords();
    drawWordCloud();
  } else {
    drawSentence();
  }
  gui();
}